//********************************************************************
//*** ResourcePool/SQL/SQLBatchCommand.cc
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLBatchCommand.hh,v 1.4 2009-03-02 14:16:45 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */


#ifndef RESOURCEPOOL_SQL_SQLBATCHCOMMAND_HH
#define RESOURCEPOOL_SQL_SQLBATCHCOMMAND_HH

#include "ResourcePool/ResourcePool.hh"
#include "ResourcePool/BatchCommand.hh"

namespace fatalmind {
namespace SQL {

template<class CommandType>
class SQLBatchCommand: public BatchCommand<CommandType>
{
	public:
		typedef BatchCommand<CommandType> super;

		SQLBatchCommand(const ResourcePool<typename CommandType::pool_type >& p, bool cont = false) 
		: super(cont)
		{
		}

		SQLBatchCommand(bool cont = false) 
		: super(cont)
		{
		}

		SQLBatchCommand(const SQLBatchCommand& rho) 
		: super(rho)
		{
		}

		virtual ~SQLBatchCommand() {
		}	

		virtual Clone* DoClone() const {
			return new SQLBatchCommand(*this);
		}
};

} // namespace SQL
} // namespace fatalmind

#endif
