//********************************************************************
//*** ResourcePool/SQL/SQLParser.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLParser.hh,v 1.2 2009-05-04 13:20:43 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef INCLUDE_SQLPARSER_HH
#define INCLUDE_SQLPARSER_HH

#include <string>

#ifndef INCLUDE_SQLSTATEMENT_LEXER
#undef yyFlexLexer
#define yyFlexLexer SQLParserFlexLexer
#include <FlexLexer.h>
#endif

namespace fatalmind {
namespace SQL {

class SQLParser: public SQLParserFlexLexer {
	public:
		SQLParser(const std::string& sql, SQLStatementImpl& stm);
	private:
		int yylex ();
		int arg_no;
		size_t begin_pos;
		size_t pos; // the current position in the inpu string
		SQLStatementImpl::Parameter param;

		SQLStatementImpl& stm;
		const std::string& sql;
};

} // namespace SQL
} // namespace fatalmind

#endif
