#include "ResourcePool/oracle/ResourcePool.hh"

#include "t/main.hh"

#include "testconfig.cc"
#include "../SQL/SQLBatch.t.cc"
#include "../SQL/SQLBatchCommand.hh"
std::auto_ptr<RP> rp;

void INIT_oracle_SQLBatch() {
	rp.reset(new RP(getFactory()));
	test_SQLBatch_init(*rp);
}

void TEST_oracle_SQLBatch_one() {
	test_SQLBatch_one(*rp);
}

void TEST_oracle_SQLBatch_fail() {
	test_SQLBatch_fail(*rp);
}

void TEST_oracle_SQLBatch_complex() {
	try {
		test_SQLBatch_complex(*rp);
	} catch (fatalmind::Exception& e) {
		// see Metalink Bug No. 7019313
		std::string version;
		RP::Commands::SQLSelectRow sel(*rp, "select version from SYS.PRODUCT_COMPONENT_VERSION where Product like 'Oracle Database%'");
		sel.bindout(0, version);
		rp->execute(sel);
		if (version.find("11.1") == 0) {
			throw SkippedException("Skipping, due to broken oracle 11.1 database (MetaLink Bug 7019313)");
		}
		throw;
	}
}
void TEST_oracle_SQLBatch_nested() {
	test_SQLBatch_nested(*rp);
}
void TEST_PERF_oracle_OptimizedBatch_ok() {
	 test_PERF_SQLBatch_ok<RP::Commands::SQLBatch>(*rp);
}

void TEST_PERF_oracle_BatchCommand_ok() {
	 test_PERF_SQLBatch_ok<fatalmind::SQL::SQLBatchCommand<RP::Commands::Base> >(*rp);
}

void TEST_PERF_oracle_SQLBatch_failoften() {
	test_PERF_SQLBatch_failoften(*rp);
}
