//********************************************************************
//*** ResourcePool/oracle/SelectListMetaDataCache.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: SelectListMetaDataCache.hh,v 1.8 2009-03-18 08:21:01 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_SELECTLISTMETADATA_HH
#include "SelectListMetaData.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_RESOURCEFWD_HH
#include "ResourceFwd.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_OCIHANDLEFWD_HH
#include "OCIHandleFwd.hh"
#endif

namespace fatalmind {
namespace oracle {

class SelectListMetaDataCtor {
    public:
        SelectListMetaDataCtor(const oracleStatement& SQL, const OCIStatementHandle& sth, oracleHandles& hand)
        : _SQL(SQL)
        , _sth(sth)
        , _hand(hand)
        {
        }

        SelectListMetaData* operator()() const {
            return new SelectListMetaData(_sth, _hand, _SQL);
        }
    private:
        const oracleStatement& _SQL;
        const OCIStatementHandle& _sth;
        oracleHandles&     _hand;
};

} // namespace oracle
} // namespace fatalmind
